#include <iostream>
#include <algorithm>
#include <vector>
#define int long long//__int128
using namespace std;
const int maxn = 1e2 + 10, base = 10;

int convert_int(const vector < int > &v) {
    int ret = 0;
    for (int i = v.size()-1 ; i >= 0 ; --i) {
        ret *= base;
        ret += v[i];
    }
    return ret;
}

vector < int > add(const vector < int > &a, const vector < int > &b) {
    vector < int > c;
    int prenos = 0;

    for (int i = 0 ; i < max(a.size(), b.size()) || prenos ; ++i) {
        if (i < a.size()) prenos += a[i];
        if (i < b.size()) prenos += b[i];
        c.push_back(prenos%base);
        prenos /= base;
    }

    return c;
}

vector < int > multiply(const vector < int > &a, const vector < int > &b) {
    vector < int > c(a.size()+b.size()+5, 0);
    //cout << "c size: " << c.size() << endl;
    int prenos = 0;

    //cout << "multiply: " << convert_int(a) << ' ' << convert_int(b) << '\n';

    for (int i = 0 ; i < a.size() ; ++i) {
        for (int j = 0 ; j < b.size() || prenos; ++j) {

            if (j < b.size()) prenos += a[i]*b[j];
            prenos += c[i+j];
            c[i+j] = prenos % base;
            prenos /= base;
            //cout << "curr: " << i << ' ' << j << ' ' << a[i] << ' ' << (j < b.size() ? b[j] : -1) << ' ' << prenos << endl;
        }
    }

    while (c.size() > 1 && c.back() == 0) c.pop_back();

    //cout << "result: " << convert_int(c) << '\n';

    return c;
}

vector < int > dp[maxn][maxn], ans={1};
int left_to_fill;
string s;

void init_dp() {
    for (int i = 0 ; i < maxn ; ++i) {
        for (int j = 0 ; j < maxn ; ++j) {
            dp[i][j] = {0};
        }
    }
 
    for (int i = 0 ; i <= left_to_fill ; ++i) dp[i][0] = {1};
    for (int i = 1 ; i <= left_to_fill ; ++i) {
        for (int j = 1 ; j <= i ; ++j) {
            dp[i][j] = add(dp[i-1][j-1], dp[i-1][j]);
            //cout << "dp[" << (long long)i <<"][" << (long long)j << "] = " << (long long)convert_int(dp[i][j]) << '\n'; 
        }
    }
}

void convert() {
    for (int i = ans.size()-1 ; i >= 0 ; --i)
        s += ans[i] + '0';
    if (s.empty()) s = "0";
    
}

long long a[maxn], n;

signed main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    
    for (int i = 1 ; i <= n ; ++i) {
        cin >> a[i];
        left_to_fill += a[i];
    }
    
    init_dp();

    for (int i = 1 ; i < n ; ++i) {
        if (a[i] == 0) {
            cout << 0 << '\n';
            return 0;
        }
        //cout << "multiply: " << ans << ' ' << left_to_fill << ' ' << a[i] << ' ' << dp[left_to_fill-1][a[i]-1] << '\n';
        ans = multiply(ans, dp[left_to_fill-1][a[i]-1]);
        //cout << "curr: " << (long long)convert_int(ans) << ' ' << (long long)convert_int(dp[left_to_fill-1][a[i]-1]) << '\n';
        left_to_fill -= a[i];
    }

    convert();

    cout << s << '\n';

    return 0;
    

}