#include <iostream>
#include <cmath>
#include <algorithm>
#pragma GCC optimize ("-O3")
using namespace std;

const long long maxn = 1e5+1;
long long n, m, k, a[maxn], ps[maxn], sum = 0, lazy[4*maxn];
struct p
{
    long long f;
    long long s;
};
p u[maxn];

void push_lazy(long long i, long long l, long long r)
{
    lazy[2*i] += lazy[i];
    lazy[2*i+1] += lazy[i];
    lazy[i] = 0;
}

void update_range(long long i, long long l, long long r, long long ql, long long qr)
{
    if(l==ql && r==qr) {++lazy[i]; return;}
    long long mid = (l+r)/2;
    if(ql > mid) update_range(2*i+1, mid+1, r, ql, qr);
    else if(qr <= mid) update_range(2*i, l, mid, ql, qr);
    else
    {
        update_range(2*i, l, mid, ql, mid);
        update_range(2*i+1, mid+1, r, mid+1, qr);
    }
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> k ;
    long long i, l, r;
    for(i=1; i<=n; ++i)
    {
        cin >> a[i] ;
        ps[i] = ps[i-1] + a[i];
        u[i].s = i;
    }
    for(i=1; i<=m; ++i)
    {
        cin >> l >> r ;
        sum += (ps[r]-ps[l-1]);
        update_range(1, 1, n, l , r);
    }
}

bool cmp(p a1, p a2)
{
    if(a1.f == a2.f) return (a1.s < a2.s);
    return (a1.f > a2.f);
}

void fill_lazy(long long i, long long l, long long r)
{
    if(l == r) {u[l].f = lazy[i]; return;}
    long long mid = (l+r)/2;
    push_lazy(i, l, r);
    fill_lazy(2*i, l, mid);
    fill_lazy(2*i+1, mid+1, r);
}

void solve()
{
    fill_lazy(1, 1, n);
    sort(u+1, u+n+1, cmp);
    long long i = 1;
    while(a[u[i].s]<=k && i<=n)
    {
        sum -= (a[u[i].s] * u[i].f);
        k -= a[u[i].s];
        ++ i;
    }
    if(k > 0) sum -= (u[i].f * k);
    if(sum < 0) sum = 0;
    cout << sum << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}